#!/usr/bin/env python
# encoding=utf-8

import pandas
import json
import re
import asyncio
import aiohttp
import async_timeout
import ast
from pandas.io.json import json_normalize

def multiple_replace(text, adict):  
     rx = re.compile('|'.join(map(re.escape, adict)))
     def one_xlat(match):  
           return adict[match.group(0)]  
     return rx.sub(one_xlat, text) 

def load(text):
    return json.loads(multiple_replace(text,{r'"{':r'{',r'}"':r'}'}))

def g(text,key):
    u=load(text)
    for i in key.replace('$.','').split('.'):
        u=u.get(i)
    return u

def e(text,target,key,value):
    u=g(text,target)
    try:
        keys, values = zip(*[(dct[key], dct[value]) for dct in u])
    except:
        keys, values = [('0',),(None,)]
    finally:
        return pandas.Series(values, index=keys)

dfs = []
def e2(row, json_col):
    json_df = pandas.DataFrame([load(row[json_col])])
    dfs.append(json_df.assign(**row))

async def fetch(session, url):
    with async_timeout.timeout(100):
        async with session.get(url) as response:
            return await response.text()


d={}
async def geturl(dataframe,k,v):
    df3=dict(zip(dataframe[k],dataframe[v]))
    async with aiohttp.ClientSession() as session:
        for a in df3:
            if df3[a] is not None:
                try:
                    d[a]=await fetch(session, df3[a])
                except:
                    print(df3[a])

def geturls(dataframe,k,v):
    asyncio.get_event_loop().run_until_complete(geturl(dataframe,k,v))
    return d


def ast2json(j):
    try:
        return ast.literal_eval(j)
    except:
        return []
def add_index(df,j):
    df['I']=j
    return df
def expand(df,key,value):
    new_dfs=pandas.DataFrame()
    for i,j,k in df[[key,value]].astype('str').itertuples():
        new_dfs=new_dfs.append(add_index(json_normalize(ast2json(k),sep='_'),j))
    # new_dfs=df[[key,value]].merge(new_dfs[:],left_on=key,right_on='I',how='left')
    new_dfs=df.merge(new_dfs[:],left_on=key,right_on='I',how='left')
    return new_dfs.drop('I',axis=1).astype('str')